/*
 *  Copyright 2019, Antoine Fontaine <antoine.fontaine@epfl.ch>
 *  I release this program under GNU GPLv3+.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#pragma once
#include <gio/gio.h>

gchar *get_resource_filename (gint res_type, guint id, const gchar *filename); // takes either a filename or an id.
gchar *get_course_filename (guint id);
gchar *get_index_filename (void);

void
read_file (const char *name, char **content, size_t *size);

// write_file is responsible for freeing content
void
write_file (const char *name, char *content, size_t size);

void
read_g_input_stream (GInputStream *is, char **content, size_t *size);

void
write_g_input_stream_to_file (GInputStream *is, const char *filename);
